{$A+,B-,D-,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 32784,0,655360}
Program PostUtil;
uses Crt,
     Dos,
     Strings,
     WriteLog,
     ReadConf;

{$I TYPES1.INC}
{$I PROD_ID.INC}
{$I CONST1.INC}
{$I STR_CNST.INC}

Var
    VersionByte           : Array[0..1] of Byte absolute VersionWord;
    LastMsgPktId          : LongInt;
    EchoFlag              : Boolean;
    Addresses             : ^FidoAddressArray;
    TextFile              : Text;
    Pkt                   : File;
    Message               : PktMsgHeader;
    Fido                  : FidoAddress;
    DefaultArea           : String;
    DefaultAreas          : ^AreasArray;
    CarbonCopies          : ^CarbonTypeArray;
    MsgStrBuf             : ^StringArray;
    CookieIndex           : ^CookieIndexType;
    CurrentLastLine       : Word;

    CurrentPktName        : String[80];

    Fdir                  : DirStr;
    FName                 : NameStr;
    FExt                  : ExtStr;

    I,J,K,L,M,N,O,P       : LongInt;
    CurrFile              : SearchRec;
    S1,S2,S3              : String;
    Region                : Byte;
    WorkFlag              : Boolean;
    TempAreaFlag          : Boolean;
    TempFileName          : Boolean;
    UUE_Founded           : Boolean;
    UUE_Founded2          : Boolean;
    FileIsList            : Boolean;
    MsgFlagsAllow         : Boolean;
    ScanDirectoriesFlag   : Boolean;
    TempArea              : String;
    TempFile              : String;
    MsgBuf                : PChar;

{$I CONFIG1.INC}

{ ------------------------------------------------------------------------ }

Procedure WriteFormat(S:String);
  begin
    Write(FormatString(S));
  end;

Procedure WriteLnFormat(S:String);
  begin
    WriteLn(FormatString(S));
  end;

Function ChangeRusN(S:String):String;
Var      I,J   : Byte;
         S1    : String;
         L     : Byte absolute S;
  begin
    S1:='';
    if L>0 then
      begin
        For I:=1 to L do
          begin
            Case S[I] of
              #141 : S1:=S1+'H';
              #9   : begin
                       for J:=1 to TabSpacingValue do
                         S1:=S1+' ';
                     end;
              else S1:=S1+S[I];
              end;
          end;
      end;
    ChangeRusN:=S1;
  end;

Function FormatSysOpName(S1:String):String;
Var
      S1L       : Byte absolute S1;
      I         : Byte;
  begin
    For I:=1 to S1L do
      begin
        If S1[I]='_' then S1[I]:=#32;
      end;
    FormatSysOpName:=S1;
  end;

Procedure WriteCurrentState(N:Byte);
  begin
    With CurrentStateStrings[N] do
      begin
        if Length(S)>0 then WriteToLogFile(S,0);
        if Length(E)>0 then WriteLnFormat (E);
      end;
  end;

Procedure ExitProcedure(ExitCode:Byte);
Var       S1:String;
  Begin
    With ErrorLevelStrings[ExitCode] do
      begin
        WritelnFormat(E);
        WriteToLogFile(S,0);
        ExitErrorLevel:=N;
        S1:=Byte2Str(ExitErrorLevel);
        Writeln;
        if Global_Error then
          begin
            WritelnFormat(FatalErrorExit.E+S1);
            CloseLogFile (FatalErrorExit.S+S1);
          end
          else
          begin
            WritelnFormat(NormalExit.E+S1);
            CloseLogFile (NormalExit.S+S1);
          end;
        Dispose(CookieIndex);
        FreeMem(CarbonCopies,    SizeOf(CarbonTypeArray));
        FreeMem(DefaultAreas,    MaxXCross*256);
        FreeMem(Message.Message, MsgMaxSize+16);
        FreeMem(MsgStrBuf,       MaxMsgLines*80);
        Dispose(Addresses);
        Halt(ExitErrorLevel);
      end;
  end;

Procedure Str2Fido       ( var AS                  : String;
                           var Fido                : FidoAddress;
                           var Region              : Byte;
                           var MiniDomen          : String;
                           var Result              : Boolean
                          );
Var
      S,S2     : String;
      SL       : Byte absolute S;
      ASL      : Byte absolute AS;
      C        : Char;
      CB       : Byte absolute C;
      I,J,K    : Byte;
      Flag     : Boolean;
      ZoneFlag,
      NetFlag,
      NodeFlag,
      PointFlag,
      MiniDomenFlag,
      DomenFlag: Boolean;

  begin
    ZoneFlag  := False;
    NetFlag   := False;
    NodeFlag  := False;
    PointFlag := False;
    DomenFlag := False;
  With Fido do
    begin
       Fido.Point:=0;
    Result:=True;
    S:='';
    Flag:=False;
    For I:=1 to ASL do
      begin
        C:=AS[I];
        Case C of
          '0'..'9' : Begin
                       S:=S+C;
                       Flag:=True;
                     end;
          ':'      : Begin
                       if Flag then Zone:=Str2Byte(S,Zone)
                               else Result:=False;
                       S:='';
                       Flag:=False;
                       ZoneFlag:=True;
                     end;
          '/'      : Begin
                       if Flag then Net:=Str2Byte(S,Net);
                       S:='';
                       Flag:=False;
                       NetFlag:=True;
                     end;
          '.'      : Begin
                       if Flag then Node:=Str2Byte(S,Node);
                       S:='';
                       Flag:=False;
                       NodeFlag:=True;
                     end;
          '@'      : Begin
                       if Flag then
                         begin
                           if NodeFlag then Point:=Str2Byte(S,Point)
                                       else
 				       begin
                                         Node :=Str2Byte(S,Node);
					 Point:=0;
        			       end;
                           Domain:='';
                           MiniDomen:='';
                           MiniDomenFlag:=True;
                           Inc(I);
                           J:=0;
                           K:=I;
                           While K<=ASL do
                             begin
                               Domain:=Domain+AS[K];
                               if AS[K]='.' then MiniDomenFlag:=False;
                               if MiniDomenFlag then MiniDomen:=MiniDomen+AS[K];
                               if Length(Domain)=40 then K:=ASL+1;
                               Inc(J);
                               K:=I+J;
                             end;
                           MiniDomen:=Copy(MiniDomen,1,8);
{                           For J:=0 to 7 do
                             begin
                               K:=I+J;
                               if K<=ASL then
                                 begin
                                   Domain:=Domain+AS[K];
                                 end
                                 else J:=7;
                             end;}
                         end
                         else
                           Result:=False;
                       S:='';
                       Flag:=False;
                       NodeFlag:=True;
                       I:=ASL;
                     end;
        end;
        if not Result then I:=ASL;
      end;
    if Flag then
      begin
        if NodeFlag
           then Point:=Str2Byte(S,Point)
           else
             begin
               if NetFlag
                  then Node:=Str2Byte(S,Node)
                  else
                    begin
                      if ZoneFlag
                         then Net:=Str2Byte(S,Net)
                         else Node:=Str2Byte(S,Node);
                    end;
             end;
      end;
    S:=Byte2Str(Net);
    S:=Copy(S,1,2);
    Region:=Str2Byte(S,Net);
    end;
  end;

Function Fido2Str     (FidoAddr:FidoAddress; Mode : Byte):String;
{         X X X X X X X X
 Mode :   7 6 5 4 3 2 1 0
                  1 = Hide Point        0 = Show Point
                 1 = Hide Node         0 = Show Node
                1 = Hide Net          0 = Show Net
               1 = Hide Zone         0 = Show Zone
              1 = Show Domain       0 = Hide Domain
             1 = UpCase Domain     0 = None
            1 = LowerCase Domain  0 = None
           1 = ?                 0 = ?
}

Var
     S: String;
     DL : Byte;
  Begin
    With FidoAddr do
      begin
        S:='';
        DL:=Length(Domain);
        if (Mode and $08)=0 then S:=S+Byte2Str(Zone)+':';
        if (Mode and $04)=0 then S:=S+Byte2Str(Net);
        if (Mode and $02)=0 then S:=S+'/'+Byte2Str(Node);
        if (Mode and $01)=0 then S:=S+'.'+Byte2Str(Point);
        if (Mode and $20)>0 then Domain:=UpCaseStrSel(Domain,1,False);
        if (Mode and $40)>0 then Domain:=UpCaseStrSel(Domain,2,False);
        if (Mode and $10)>0 then
          begin
            If DL>0 then
              S:=S+'@'+Domain;
          end;
        Fido2Str:=S;
      end;
  end;

Procedure CheckFile     (var FilePath : String;
                         var Result   : Boolean
                         );
var
    S: String;
    P: String;
    D: DirStr;
    N: NameStr;
    E: ExtStr;
  begin
    P:=GetEnv('PATH');
    S:=FSearch(FilePath,P);
    if S='' then Result:=False
            else
              begin
                Result:=True;
                FilePath:=FExpand(S);
              end;
  end;

Procedure AddArea2List(S:String);
var
        ViewInList        : Boolean;
        I,J,K             : Integer;
  begin
    Inc(XCrossCounter);
    S:=UpCaseStr(S);
    StrValues[27]:=S;
    if XCrossCounter > MaxXCross then
      begin
        XCrossCounter:=MaxXCross;
        WriteCurrentState(2);
      end
      else
      begin
        ViewInList:=True;
        Case  S[1] of
          '!','#'  : Begin
                       S:=Copy(S,2,74);
                       ViewInList:=False;
                     end;
          end;
        K:=XCrossCounter;
        For I:=0 to XCrossCounter-1 do
          begin
            if DefaultAreas^[XCrossCounter].N=S then
              begin
                K:=I;
                I:=XCrossCounter;
                Dec(XCrossCounter);
              end;
          end;
        StrValues[27]:=S;
        DefaultAreas^[K].N:=S;
        DefaultAreas^[K].ViewInList:=ViewInList;
        WriteCurrentState(1);
      end;
  end;

Procedure AddAddress2List(A,N:String);
Var
   Fido,Fido2   : FidoAddress;
   MDomain      : String;
   Region       : Byte;
   Result       : Boolean;
   ViewInList   : Boolean;
   I,J,K        : Integer;
   S1,S2        : String;
  begin
    StrValues[27]:=A;
    ViewInList:=True;
    Case A[1] of
      '!','#' : Begin
                  ViewInList:=False;
                  A:=Copy(A,2,74);
                end;
      end;
    Fido:=DefaultFidoAddress;
    Str2Fido(A,Fido,Region,MDomain,Result);
    if Result then
      begin
        Inc(CCopyCounter);
        StrValues[27]:=Fido2Str(Fido,16);
        if CCopyCounter > MaxCCopy then
          begin
            CCopyCounter:=MaxCCopy;
            WriteCurrentState(19);
          end
          else
          begin
            if N='' then N:='SysOp';
            K:=CCopyCounter;
            For I:=0 to CCopyCounter-1 do
              begin
                S1 := Fido2Str(CarbonCopies^[I].Adr,16);
                S2 := Fido2Str(Fido,16);
                if ((CarbonCopies^[I].Name=N   ) and
                    (S1 = S2))
                  then
                  begin
                    K:=I;
                    I:=CCopyCounter-1;
                    Dec(CCopyCounter);
                  end;
              end;
            CarbonCopies^[K].Adr :=Fido;
            CarbonCopies^[K].Name:=N;
            CarbonCopies^[K].ViewInList:=ViewInList;
            WriteCurrentState(18);
          end;
      end
      else
      begin
        StrValues[27]:=A;
        WriteCurrentState(15);
      end;
  end;

Procedure ReadXCrossFile(S:String);
Var
        S1,S2,S3,S4             : String;
        ParamCnt                : Byte;
        Result                  : Boolean;
  begin
    if S<>'' then
      begin
        WriteCurrentState(11);
        CheckFile(S,Result);
        if Result then
          begin
            Assign(TextFile,S);
            Reset(TextFile);
            While not EOF(TextFile) do
              begin
                Readln(TextFile,S4);
                CompileString(S4,ParamArray,ParamCnt);
                if ParamArray[0][0]>#0 then
                  begin
                    AddArea2List(ParamArray[0]);
                  end;
              end;
          end
          else
          begin
            WriteCurrentState(12);
          end;
      end;
  end;

Procedure ReadCCopyFile(S:String);
Var
        S1,S2,S3,S4             : String;
        ParamCnt                : Byte;
        Result                  : Boolean;
  begin
    if S<>'' then
      begin
        WriteCurrentState(13);
        CheckFile(S,Result);
        if Result then
          begin
            Assign(TextFile,S);
            Reset(TextFile);
            While not EOF(TextFile) do
              begin
                Readln(TextFile,S4);
                CompileString(S4,ParamArray,ParamCnt);
                if ParamArray[0][0]>#0 then
                  begin
                    AddAddress2List(ParamArray[0],ParamArray[1]);
                  end;
              end;
          end
          else
          begin
            WriteCurrentState(14);
          end;
      end;
  end;

{ Com_ Procedures -------------------------------------------------------- }

Procedure Com_File         (Command    : Word;
                            ParamCnt   : Byte;
                            var Params : ReadyParamsArray;
                            var Result : Boolean); Far;

(*
begin
*)

Var
       S        : String;
  begin
    Result:=True;
    Inc(CommandScanned);
    if Params[1].N=0 then
      begin
        S:=UpCaseStr(FormatString(Params[1].S));
        CheckFile(S,Result);
          Case Command of
            0  : begin
                   if S<>FileNames[0] then
                     begin
                     StrValues[27]:=S;
                     WriteCurrentState(0);
                     CloseLogFile('%SS%D4%DD/%DM %TT ! This Log is closed.%SL');
                     FileNames[0]:=S;
                     OpenLogFile(FileNames[0],'%D4%DD/%DM %TT %RW v.%RX.');
                     Result:=True;
                     end;
                 end;
             end;
	  FileNames[Command]:=S;
      end;
    {Writeln('FILE: ',FileNames[Command]);}
  end;

Procedure Com_Ext          (Command    : Word;
                            ParamCnt   : Byte;
                            var Params : ReadyParamsArray;
                            var Result : Boolean); Far;
Var    I                    : Byte;
  begin
    Result:=True;
    Inc(CommandScanned);
    I:=Command-InpExtOffs;
    if Params[1].N=0 then
      begin
	Extensions[I]:=UpCaseStr(FormatString(Params[1].S));
      end;
    {Writeln('EXT:  ',Extensions[I]);}
  end;

Procedure Com_Path         (Command    : Word;
                            ParamCnt   : Byte;
                            var Params : ReadyParamsArray;
                            var Result : Boolean); Far;
Var    I                    : Byte;
       S                    : String;
       L                    : Byte Absolute S;
  begin
    Result:=True;
    Inc(CommandScanned);
    I:=Command-WorkDirOffs;
    if Params[1].N=0 then
      begin
        S:=UpCaseStr(FormatString(Params[1].S));
        S:=FExpand(S);
        if S[L]<>'\' then S:=S+'\';
        Directory[I]:=S;
      end;
{    Writeln('PATH: ',Directory[I]);}
  end;

Procedure Com_Addr         (Command    : Word;
                            ParamCnt   : Byte;
                            var Params : ReadyParamsArray;
                            var Result : Boolean); Far;
Var    I                    : Byte;
       S,MDomain            : String;
       Fido                 : FidoAddress;
       Region               : Byte;
       Flag                 : Boolean;
  begin
    Result:=True;
    Inc(CommandScanned);
    Command:=Command-AddrOffs;
    I:=Command;
    Fido:=DefaultFidoAddress;
    S:=FormatString(Params[1].S);
    if Params[1].N=0 then
      begin
	Str2Fido(S,Fido,Region,MDomain,Flag);
        if Flag then
          begin
            Addresses^[I]:=Fido;
            Case Command of
              0  : DefaultFidoAddress:=Fido;
              1  : DefaultFrom.Adr:=Fido;
              2  : Begin
                     DefaultTo.Adr:=Fido;
                   end;
              end;
          end;
      end;
{    Writeln('Address: ',Fido2Str(Fido,16));}
  end;

Procedure Com_AreaName     (Command    : Word;
                            ParamCnt   : Byte;
                            var Params : ReadyParamsArray;
                            var Result : Boolean); Far;
  begin
    Result:=True;
    Inc(CommandScanned);
    if ((Params[1].N=0) and (XCrossCounter<0)) then
      begin
        XCrossCounter:=-1;
        AddArea2List(UpCaseStr(Params[1].S));
      end;
  end;

Procedure Com_PacketMode   (Command    : Word;
                            ParamCnt   : Byte;
                            var Params : ReadyParamsArray;
                            var Result : Boolean); Far;
  begin
    Result:=True;
    Inc(CommandScanned);
    if Params[1].N<>ErrorLongInt then
      begin
        PacketMode:=Params[1].N;
        if PacketMode=2 then ShowDomainFlag:=True;
      end;
  end;

Procedure Com_PktSize      (Command    : Word;
                            ParamCnt   : Byte;
                            var Params : ReadyParamsArray;
                            var Result : Boolean); Far;
  begin
    Result:=True;
    Inc(CommandScanned);
    if Params[1].N<>ErrorLongInt then
      begin
        PktMaxSize:=((Params[1].N) and 1023)*1024;
      end;
  end;

Procedure SetBooleanSets;
  begin
    BooleanSets[0,0] :=True;
    BooleanSets[0,13]:=False;
    BooleanSets[0,1] :=BooleanSets[0,2];
    BooleanSets[0,3] :=BooleanSets[0,4];
    BooleanSets[0,5] :=BooleanSets[0,6];
    BooleanSets[0,7] :=BooleanSets[0,8];
    BooleanSets[0,9] :=BooleanSets[0,10];
    BooleanSets[0,11]:=BooleanSets[0,12];
  end;

Procedure ChangeBooleanSets(S:String;var Result:Boolean);
Var   I   : Byte;
      L   : Byte absolute S;
  begin
    Result:=True;
    if L=0 then
      begin
        Result:=False;
      end
      else
        begin
          StrValues[27]:=S;
          WriteCurrentState(3); { Message Sets Set to ????? }
          For I:=1 to L do
            begin
              Case UpCase(S[I]) of
                'D' : BooleanSets[0,2] :=False;
                'F' : BooleanSets[0,4] :=False;
                'C' : BooleanSets[0,6] :=False;
                'E' : BooleanSets[0,8] :=False;
                'N' : BooleanSets[0,10]:=False;
                'R' : BooleanSets[0,12]:=False;
                end;
            end;
        end;
  end;

Procedure Com_MsgSets      (Command    : Word;
                            ParamCnt   : Byte;
                            var Params : ReadyParamsArray;
                            var Result : Boolean); Far;
Var    I                    : Byte;
  begin
    Result:=True;
    Inc(CommandScanned);
    SetBooleanSets;
    if Params[1].N=0 then
      begin
	ChangeBooleanSets(Params[1].S,Result);
      end;
  end;

Procedure Com_UUESubj      (Command    : Word;
                            ParamCnt   : Byte;
                            var Params : ReadyParamsArray;
                            var Result : Boolean); Far;
Var    I                    : Byte;
  begin
    Result:=True;
    Inc(CommandScanned);
    if Params[1].N=0 then
      begin
	UUE_AddSubj:=Params[1].S;
        if Params[2].N=0 then UUE_AddFlag:=True
                         else UUE_AddFlag:=False;
      end;
{    Writeln('OTHER: ',Params[1].S);}
  end;

Procedure Com_TabSpace     (Command    : Word;
                            ParamCnt   : Byte;
                            var Params : ReadyParamsArray;
                            var Result : Boolean); Far;
  begin
    Result:=True;
    Inc(CommandScanned);
    if Params[1].N<>ErrorLongInt then
      begin
	TabSpacingValue:=Params[1].N;
      end;
  end;

Procedure Com_PostFMode    (Command    : Word;
                            ParamCnt   : Byte;
                            var Params : ReadyParamsArray;
                            var Result : Boolean); Far;
Var    I                    : Byte;
  begin
    Result:=True;
    Inc(CommandScanned);
    if Params[1].N<>ErrorLongInt then
      begin
	PostFileMode:=Params[1].N;
        if Params[2].N<>ErrorLongInt then
          begin
            Period:=Params[2].N;
          end;
      end;
  end;

Procedure Com_Adr          (Command    : Word;
                            ParamCnt   : Byte;
                            var Params : ReadyParamsArray;
                            var Result : Boolean); Far;
Var    I                    : Byte;
  begin
    Result:=True;
    Inc(CommandScanned);
{    if Params[1].N=0 then
      begin
	Extensions[I]:=UpCaseStr(FormatString(Params[1].S));
      end;}
{    Writeln('OTHER: ',Params[1].S);}
  end;

Procedure Com_CookieMode   (Command    : Word;
                            ParamCnt   : Byte;
                            var Params : ReadyParamsArray;
                            var Result : Boolean); Far;
  begin
    Result:=True;
    Inc(CommandScanned);
    if Params[1].N<>ErrorLongInt then
      begin
        CookieMode:=Params[1].N;
      end;
  end;

Procedure Com_DublSubj     (Command    : Word;
                            ParamCnt   : Byte;
                            var Params : ReadyParamsArray;
                            var Result : Boolean); Far;
  begin
    Result:=True;
    Inc(CommandScanned);
    if Params[1].N=0 then
      begin
        if Params[1].S[0]>#0 then
          begin
            MsgStrings[5]:=Params[1].S;
          end
          else
          begin
            MsgStrings[5]:='%R8';
          end;
      end;
    if Params[2].N=0 then
      begin
	DublSubjFlag:=True;
      end
      else
      begin
        DublSubjFlag:=False;
      end;
  end;

Procedure Com_XCEcho       (Command    : Word;
                            ParamCnt   : Byte;
                            var Params : ReadyParamsArray;
                            var Result : Boolean); Far;
Var    I                    : Byte;
  begin
    Result:=True;
    Inc(CommandScanned);
    if Params[1].N<>ErrorLongInt then
      XCrossMode:=Params[1].N;
    If ParamCnt>1 then
      For I:=2 to ParamCnt do
        begin
          if ((Params[I].N=0) and (Params[I].S>#0))
            then XCrossString[I-2]:=Params[I].S;
          if I=3 then I:=ParamCnt;
        end;
  end;

Procedure Com_CCEcho       (Command    : Word;
                            ParamCnt   : Byte;
                            var Params : ReadyParamsArray;
                            var Result : Boolean); Far;
Var    I                    : Byte;
  begin
    Result:=True;
    Inc(CommandScanned);
    if Params[1].N<>ErrorLongInt then CCopyMode:=Params[1].N
                                 else CCopyMode:=2;
    if Params[2].N<>ErrorLongInt then CCViewMode:=Params[2].N
                                 else CCViewMode:=1;
    if Params[3].N<>ErrorLongInt then CCAdrMode:=Params[3].N
                                 else CCAdrMode:=16;
    If ParamCnt>3 then
      For I:=4 to ParamCnt do
        begin
          if Params[I].N=0 then CCopyString[I-4]:=Params[I].S;
          if I=5 then I:=ParamCnt;
        end;
  end;

Procedure Com_MsgFlags     (Command    : Word;
                            ParamCnt   : Byte;
                            var Params : ReadyParamsArray;
                            var Result : Boolean); Far;
Var I        : Byte;
  begin
    Result:=True;
    Inc(CommandScanned);
    if not MsgFlagsAllow then Exit;
    For I:=1 to ParamCnt do
      begin
        if Params[I].N<>ErrorLongInt then
          begin
            if Params[I].N<16
              then
                begin
                  if Params[I].N=10 then
                    begin
                      MsgFlags:=0;
                      MsgFlags2:=0;
                    end
                    else
                      MsgFlags:=(MsgFlags or FlagMask[Params[I].N])
                end
              else
                MsgFlags2:=(MsgFlags2 or FlagMask[Params[I].N-16]);
          end;
      end;
  end;

Procedure Com_MsgString    (Command    : Word;
                            ParamCnt   : Byte;
                            var Params : ReadyParamsArray;
                            var Result : Boolean); Far;
  begin
    Result:=True;
    Inc(CommandScanned);
    Command:=Command-SubjOffs;
    if Params[1].N=0 then
      MsgStrings[Command]:=Params[1].S;
    Case Command of
      3   : Begin
              DefaultFrom.Name:=MsgStrings[3];
            end;
      4   : Begin
              DefaultTo.Name  :=MsgStrings[4];
            end;
      end;
{    Writeln('STR: ',MsgStrings[Command]);}
  end;

Const
        PostUtilCommandsRun     : Array[0..MaxNumberCommand] of CommandRun =
            (Com_File, Com_File, Com_File, Com_File,
             Com_File, Com_File, Com_File,   { FileNames  (00-06) }
             Com_Ext,  Com_Ext,              { FileExt's  (07-08) }
             Com_Path, Com_Path, Com_Path, Com_Path,
             Com_Path, Com_Path,             { Paths      (09-14) }
             Com_MsgString, Com_MsgString, Com_MsgString,
             Com_MsgString, Com_MsgString,   { MsgStrings (15-19) }
             Com_Addr, Com_Addr, Com_Addr,
             Com_Addr, Com_Addr,             { Addresses  (20-24) }
             Com_Adr, Com_Adr, Com_Adr, Com_Adr,
             Com_Adr, Com_Adr, Com_Adr,
             Com_PktSize,                    { PktSize         32 }
             Com_AreaName,                   { AreaName        33 }
             Com_PacketMode,                 { PacketMode      34 }
             Com_MsgFlags,                   { MsgFlags        35 }
             Com_DublSubj,                   { DublSubj        36 }
             Com_MsgSets,                    { MsgSets         37 }
             Com_UUESubj,                    { UUESubj         38 }
             Com_PostFMode,                  { PostFileMode    39 }
             Com_TabSpace,                   { TabSpacing      40 }
             Com_XCEcho,                     { XCrossEcho      41 }
             Com_CCEcho,                     { CCopyEcho       42 }
             Com_CookieMode                  { CookieMode      43 }
             );

Function DateF(D,M,Y:Word;var Week:Word):LongInt;
Var
      F,A,B         : LongInt;
  begin
    A:=(365*Y)+D+31*(M-1);
    B:=Y-1;
    if M<3 then
      begin
        B:=(B div 4)-((((B div 100)+1)*3) div 4);
        F:=A-B;
      end
      else
      begin
        B:=((4*M+23) div 10)+(Y div 4)-((((Y div 100)+1)*3) div 4);
        F:=A+B;
      end;
    DateF:=F;
    Week :=F-7*(F div 7);
    if Week=0 then Week:=7;
    Dec(Week)
  end;

Function IdGenerate:LongInt;
Var
     D,M,Y,W,H,Mn,S,Ss          : Word;
     L1,L2,L3,L4                : LongInt;
     F,R                        : LongInt;
     BL                         : Array[0..7] of Byte absolute F;
  begin
    repeat
      GetDate(Y,M,D,W);
      F:=DateF(D,M,Y,W)-7465;
      GetTime(H,Mn,S,Ss);
      Ss:=(Ss shr 3) and $000F;
      R:=S+Mn*60+H*3600;
      F:=((F*86400+R) shl 4) or Ss;
    until F<>LastMsgPktId;
    IdGenerate:=F;
    IntValues[35]:=F;
    LastMsgPktId:=F;
  end;

Procedure CreateNewPkt(var Result:Boolean);
Var
          PktHeader   : PktFileHeader;
          I,J,K       : Word;
          MDomain,Ads : String;
          FidoTmp     : FidoAddress;
          Region      : Byte;
          ResultTmp   : Boolean;
  Begin
    Result:=True;
    IntValues[35]  := IdGenerate;
    CurrentPktName := FormatString(Directory[3]+'%SS%ML8%HZ%SL.PKT');
    Assign (PKT, CurrentPktName);
    {$I-}
    ReWrite(PKT,1);
    {$I+}
    if IOResult<>0 then
      begin
        StrValues[27]:=Directory[3];
        ExitProcedure(7);
      end;
    WriteCurrentState(4);
    { ନ஢    .PKT }
    With PktHeader do
      begin
        With Addresses^[3] do
          begin
            OrigZone := Zone;  { 2 /2+ - Originating Zone           34 : 2 }
                               { 2.2   - Originating Zone           34 : 2 }
            OrigNet  := Net;   { 2 /2+ - Originating Network
                                   /2+ - if Origin - point = -1     20 : 2 }
                               { 2.2   - Originating Network        20 : 2 }
            OrigNode := Node;  { Originating Node Number             0 : 2 }
            Year     := Point; { 2.2   - Originating Point Number    4 : 2 }
          end;
        With Addresses^[4] do
          begin
            DestZone := Zone;  { 2 /2+ - Destination Zone           36 : 2 }
                               { 2.2   - Destination Zone           36 : 2 }
            DestNet  := Net;   { 2 /2+ - Destination Network        22 : 2 }
                               { 2.2   - Destination Network        22 : 2 }
            DestNode := Node;  { Destination Node Number             2 : 2 }
            Month    := Point; { 2.2   - Destination Point Number    6 : 2 }
          end;
        For I:=0 to 7 do
          begin
            Password[I]  :=#0;
            Binary[I+38] :=0;
            Binary[I+46] :=0;
            Binary[I+8]  :=0;
          end;
        if PacketMode=2 then
          begin
            Baud := 2;         { 2.2   - Packet Sub Version (2)     16 : 2 }
            Ads:=Fido2Str(Addresses^[3],16);
            Str2Fido(Ads,FidoTmp,Region,MDomain,ResultTmp);
            For I:=0 to 7 do
              begin
                If I>Length(MDomain) then
                  Binary[38+I]:=0    else
                  Binary[38+I]:=Ord(MDomain[I+1]);
              end;
                               { 2.2   - Originating Domain         38 : 8 }
            Ads:=Fido2Str(Addresses^[4],16);
            Str2Fido(Ads,FidoTmp,Region,MDomain,ResultTmp);
            For I:=0 to 7 do
              begin
                If I>Length(MDomain) then
                  Binary[46+I]:=0    else
                  Binary[46+I]:=Ord(MDomain[I+1]);
              end;
                               { 2.2   - Destination Domain         46 : 8 }
          end
          else
          begin
            if PacketMode = 1 then
              begin
                If Year>0 then
                  begin
                    AuxNet := OrigNet;
                               {   /2+ - Contains OrigNet if
                                         Origin is a point          38 : 2 }
                    OrigNet:= 65535;
                  end;
              end;
            OrigPoint:=Year;
            DestPoint:=Month;
            GetDate(Year,Month,Day,K);
            Dec(Month);
                               { 2 /2+ - Year of packet created      4 : 2 }
                               { 2 /2+ - Month of packet created     6 : 2 }
                               { 2 /2+ - Day of packet created       8 : 2 }
            GetTime(Hour,Min,Sec,K);
                               { 2 /2+ - Hour of packet created     10 : 2 }
                               { 2 /2+ - Minute of packet created   12 : 2 }
                               { 2 /2+ - Seconds of packet created  14 : 2 }
            Baud     := 0;     { 2 /2+ - Baud (use 0)               16 : 2 }
            ProdCode2:= 0;     {   /2+ - Product Code (Hi)          42 : 1 }
            SerialNo2:= VersionByte[0];
                               {   /2+ - Revision level (Low)       43 : 1 }
            CapValid := $0100; {   /2+ - Byte-swapped copy of
                                         Compatibility Word         40 : 2 }
            CapWord  := $0001; {   /2+ - Compatibility Word         44 : 2 }
            FromZone := OrigZone; {   /2+ - Originating Zone           46 : 2 }
            ToZone   := DestZone; {   /2+ - Destination Zone           48 : 2 }
          end;

        PktType  := 2;  { 2 /2+ - Packet Version (2)         18 : 2 }
                        { 2.2   - Packet Version (2)         18 : 2 }
        ProdCode := 0;  { 2 /2+ - ProductCode (FTSC product) 24 : 2 }
                        { 2.2   - ProductCode (FTSC product) 24 : 1 }
        SerialNo := VersionByte[1];
                        { 2 /2+ - Product revision level
                                  (Relise version)           25 : 1 }
                        { 2.2   - Product revision level
                                  (Relise version)           25 : 1 }
        For I:=1 to Length(PktPassword) do
          begin
            Password[I-1]:=PktPassword[I];
                        { 2 /2+ - Packet password            26 : 8 }
                        { 2.2   - Packet password            26 : 8 }
          end;

        ProdData1:= $5343;  {   /2+ - Product Data (ignored)     54 : 2 }
                            { 2.2   - Product Data (ignored)     54 : 2 }
        ProdData2:= $0043;  {   /2+ - Product Data (ignored)     56 : 2 }
                            { 2.2   - Product Data (ignored)     56 : 2 }
      end;
    BlockWrite(PKT,PktHeader,SizeOf(PktHeader),K);
    if K<58 then Result:=False;
  end;

Function PackCurrentTime:LongInt;
Var
     TimeR       : DateTime;
     W1,W2,W3,W4 : Word;
     Sz          : LongInt;
  begin
    With TimeR do
      begin
        GetDate(W1,W2,W3,W4);
        Year:=W1;
        Month:=W2;
        Day:=W3;
        GetTime(W1,W2,W3,W4);
        Hour:=W1;
        Min:=W2;
        Sec:=W3;
      end;
    PackTime(TimeR,Sz);
    PackCurrentTime:=Sz;
  end;

Procedure ClosePktFile(var Result:Boolean);
Var  W : Word;
     Sz  : LongInt;
     S   : String;
     F   : File;
  Begin
    Result:=True;
    BlockWrite(PKT,PktTerminator,2,W);
    if W<2 then Result:=False;
    Sz:=FileSize(PKT);
    Close(PKT);
    if Sz<=60 then
      begin
        WriteCurrentState(17);
        Erase(PKT);
      end
      else
      begin
        S:=FileNames[5];
        CheckFile(S,Result);
        Assign(F,S);
        if not Result
          then ReWrite(F)
          else
            begin
              Reset(F,1);
              SetFTime(F,PackCurrentTime);
            end;
        Close(F);
      end;
  end;

Procedure AddLineToPChar (S2         : String;
                          Message    : PChar;
                          Flag       : Boolean);
Var
      TempChars         : Array[0..257] of Char;
  begin
    if Flag then S2:=FormatString(S2);
    S2 := ChangeRusN(S2);
    StrPCopy (TempChars, S2);
    StrCat   (Message,   TempChars);
  end;

Procedure AddLineToPkt   (S2         : String;var Result:Boolean);
Var
      TempChars         : Array[0..257] of Char;
      J,K               : Word;
  begin
    Result:=True;
    S2:=FormatString(S2);
    J:=Length  (S2)+1;
    StrPCopy   (TempChars, ChangeRusN(S2));
    BlockWrite (PKT, TempChars, J, K);
    if K<J then Result:=False;
  end;

Procedure AddMessageToPkt(MsgHeader:PktMsgHeader; var Result:Boolean);
Var
          S1,S2,S3    : String;
          I,J,K       : Word;
          TempChars   : Array[0..79] of Char;
  begin
    Result:=True;
    If FileSize(PKT)>PktMaxSize then
      begin
        ClosePktFile(Result);
        CreateNewPkt(Result);
        if not Result then Exit;
      end;
    BlockWrite(PKT,MsgHeader,34,K);
    With MsgHeader do
      begin
        if K<34 then Result:=False;
        If Result then AddLineToPkt(ToUser,  Result);
        If Result then AddLineToPkt(FromUser,Result);
        If Result then AddLineToPkt(Subject, Result);
        If Result then
          begin
            J:=StrLen(MsgHeader.Message)+1;
            BlockWrite(PKT,MsgHeader.Message^,J,K);
            if K<J then Result:=False
                   else MsgHeader.Message[0]:=#0;
          end;
      end;
  end;

Procedure InitPathSeenBy;
Var
      S2        : String;
      I         : Byte;
      TempNet   : Array[0..2] of LongInt;
      TempNode  : Array[0..2] of LongInt;
  begin
    For I:=0 to 2 do
      begin
        TempNet [I]:=-1;
        TempNode[I]:=-1;
      end;
    TempNet [0]:=Addresses^[3].Net;    { FromPkt }
    TempNode[0]:=Addresses^[3].Node;

    if (((TempNet[0]=999) or (TempNet[0]=9999)) and
        ((TempNode[0]=999) or (TempNode[0]=9999))) then
      begin
        ShowSeenByFlag:=False;
        ShowPathFlag:=False;
      end
      else
      begin
        ShowSeenByFlag:=True;
        ShowPathFlag:=True;
      end;

    TempNet [1]:=Addresses^[4].Net;    { ToPkt   }
    TempNode[1]:=Addresses^[4].Node;
                                { -------- PATH:  Default --------- }
    DefaultEchoPath:=Byte2Str(TempNet[0])+'/'+Byte2Str(TempNode[0]);
    if TempNet[0]=TempNet[1]    { ------- SEEN-BY: Default -------- }
      then
        begin
          if TempNode[0]=TempNode[1] then
            begin
              TempNode[1]:=-1;
            end
            else
              begin
                if TempNode[0]>TempNode[1] then
                  begin
                    TempNode[2]:=TempNode[0];
                    TempNode[0]:=TempNode[1];
                    TempNode[1]:=TempNode[2];
                  end;
              end;
            TempNet[1]:=-1;
        end
        else
          begin
            if TempNet[0]>TempNet[1] then
              begin
                TempNet [2] := TempNet [0];
                TempNet [0] := TempNet [1];
                TempNet [1] := TempNet [2];
                TempNode[2] := TempNode[0];
                TempNode[0] := TempNode[1];
                TempNode[1] := TempNode[2];
              end;
          end;
      S2:='';
      For I:=0 to 1 do
        begin
          if TempNet[I]>-1 then
            begin
              S2:=S2+Byte2Str(TempNet[I])+'/';
            end;
          if TempNode[I]>-1 then
            begin
              S2:=S2+Byte2Str(TempNode[I])+' ';
            end;
        end;
      DefaultSeenBy:=S2;
  end;

Procedure FirstCludges(Var Msg:PktMsgHeader);
Var       S1,S2,S3,
          MDomain     : String;
          I,J,K       : Word;
          TempChars   : Array[0..255] of Char;
          TF          : Text;
          Fido        : FidoAddress;
          Region      : Byte;
          Result      : Boolean;
  begin
    With Msg do
      begin
        S2:=ChangeRusN(MsgStrings[4]);
        StrValues[0] :=S2;                            { %R0 }
        StrValues[1] :=ReadToSpace(S2);               { %R1 }
        StrValues[2] :=Addresses^[2].Domain;          { %R2 }
        StrValues[3] :=Fido2Str(Addresses^[2],16);    { %R3 }
        S2:=ChangeRusN(MsgStrings[3]);
        StrValues[4] :=S2;                            { %R4 }
        StrValues[5] :=ReadToSpace(S2);               { %R5 }
        StrValues[6] :=Addresses^[1].Domain;          { %R6 }
        StrValues[7] :=Fido2Str(Addresses^[1],16);    { %R7 }
        StrValues[8] :=ChangeRusN(FormatString(MsgStrings[0]));     { %R8 }
        StrValues[9] :=ChangeRusN(FormatString(MsgStrings[2]));     { %R9 }
        StrValues[10]:=ChangeRusN(FormatString(MsgStrings[1]));     { %RA }
        if CookieMode=0 then StrValues[11]:='';       { %RB }
        If EchoFlag then StrValues[12]:=DefaultArea   { %RC }
                    else StrValues[12]:='NETMAIL';
        Str2Fido(StrValues[7],Fido,Region,MDomain,Result);
        With Addresses^[1] do
          begin
            IntValues[0] :=Zone;
            IntValues[2] :=Net;
            IntValues[4] :=Region;
            IntValues[6] :=Node;
            IntValues[8] :=Point;
          end;
        Str2Fido(StrValues[3],Fido,Region,MDomain,Result);
        With Addresses^[2] do
          begin
            IntValues[1] :=Zone;
            IntValues[3] :=Net;
            IntValues[5] :=Region;
            IntValues[7] :=Node;
            IntValues[9] :=Point;
          end;
        IntValues[35]:=IdGenerate; { %HZ - MSGID: cludge value }
        S2:='';
        For I:=0 to 15 do
          begin
            If (MsgFlags2 and FlagMask[I])>0 then
              begin
                S2:=S2+' '+CountedStringMsgFlags[I+16];
              end;
          end;
        StrValues[27]:=S2;
        If BooleanSets[0,0] then
          begin
            If EchoFlag then AddLineToPChar(AreaCludgeMask,Message,True);
            AddLineToPChar(MsgIdCludgeMask,Message,True);
 {            S2:=FormatString(DomainCludgeMask);
              StrPCopy(TempChars,S2);
              StrCat(Message,TempChars); }
            If Not EchoFlag then
              begin
                AddLineToPChar(IntlCludgeMask,Message,True);
                if IntValues[8]<>0 then
                  AddLineToPChar(FmPtCludgeMask,Message,True);
                if IntValues[9]<>0 then
                  AddLineToPChar(ToPtCludgeMask,Message,True);
                if MsgFlags2>0 then
                  AddLineToPChar(FlagCludgeMask,Message,True);
                if ShowDomainFlag then
                  AddLineToPChar(DomainCludgeMask,Message,True);
              end;
            AddLineToPChar(PidCludgeMask,Message,True);
          end;
      end;
  end;

Procedure EndCludges(Var Msg:PktMsgHeader);
Var       S1,S2,S3    : String;
          I,J,K       : Word;
          TempChars   : Array[0..255] of Char;
          TF          : Text;
          Fido        : FidoAddress;
          Region      : Byte;
          Result      : Boolean;
          TempNet     : Array[0..2] of LongInt;
          TempNode    : Array[0..2] of LongInt;
  begin
    With Msg do
      begin
        If BooleanSets[0,0] then
          begin
            S2:='--- '+StrValues[10]+#13;                        { TearLin }
            AddLineToPChar(S2,Message,False);
            if EchoFlag then
              begin
                if Addresses^[1].Point=0 then I:=1               { Origin  }
                                         else I:=0;
                S1:='('+Fido2Str(Addresses^[1],I)+')'+#13;
                I:=Length(StrValues[9]);
                J:=Length(S1)+11;
                K:=I+J;
                if K>79 then
                  begin
                    K:=K-80;
                    I:=I-K;
                    StrValues[9]:=Copy(StrValues[9],1,I);
                  end;
                S2:=' * Origin: '+StrValues[9]+' '+S1;
                AddLineToPChar(S2,Message,False);

                If ShowSeenByFlag then
                  begin
                    StrValues[27]:=DefaultSeenBy;            { SEEN-BY }
                    AddLineToPChar(SeenByCludgeMask,Message,True);
                  end;
                If ShowPathFlag then
                  begin
                    StrValues[27]:=DefaultEchoPath;          { ^APATH: }
                    AddLineToPChar(PathCludgeMask,Message,True);
                  end;
                StrValues[27]:='';
              end
              else
              begin
                if ViaCludgeType>0 then                          { ^AVia   }
                  begin
                    AddLineToPChar(ViaCludgeMasks[ViaCludgeType],
                                   Message,True);
                  end;
              end;
          end;
      end;
  end;

Procedure SaveFlags;
var I:Byte;
  begin
    For I:=0 to MaxMsgSwitch do
      begin
        BooleanSets[1,I]:=BooleanSets[0,I];
      end;
  end;

Procedure LoadFlags;
var I:Byte;
  begin
    For I:=0 to MaxMsgSwitch do
      begin
        BooleanSets[0,I]:=BooleanSets[1,I];
      end;
  end;

Procedure StringHaveUUE(S:String);
Var
    ParamCnt    : Byte;
    I,J,K       : Byte;
    W1,W2       : LongInt;
    Flag        : Boolean;
    SF          : String;

Procedure SetToUUE;
  begin
    SaveFlags;
    BooleanSets[0,1]:=False;
    BooleanSets[0,3]:=False;
    BooleanSets[0,5]:=False;
    BooleanSets[0,11]:=False;
    Flag:=True;
    UUE_Founded:=True;
    UUE_Founded2:=True;
  end;

Procedure SetFromUUE;
  begin
    LoadFlags;
    Flag:=True;
    UUE_Founded:=False;
  end;

  begin
    ParamCnt:=15;
    Flag:=False;
    CompileString(S,ParamArray,ParamCnt);
    W1:=0;
    W2:=W1;
    if ((ParamArray[0]='section')and(not UUE_Founded)) then
      begin
        Flag:=True;
        if ParamArray[2]='of' then
          begin
            W1:=Str2Byte(ParamArray[1],-2);
            if W1>0 then
              begin
                if ParamArray[3]='uuencode'
                  then
                    begin     { UUENCODE v.5.25- }
                      SF:=ParamArray[7];
                      IntValues[30]:=W1;
                      IntValues[31]:=W2;
                      StrValues[14]:=UpCaseStr(SF);
                      SetToUUE;
                    end
                  else
                    begin     { UUENCODE v.5.32+ }
                      if ((ParamArray[4]='of') and
                          (ParamArray[5]='file')) then
                        begin
                          W2:=Str2Byte(ParamArray[3],-2);
                          if W2>0 then
                            begin
                              SF:=ParamArray[6];
                              IntValues[30]:=W1;
                              IntValues[31]:=W2;
                              StrValues[14]:=UpCaseStr(SF);
                              SetToUUE;
                            end;
                        end;
                    end;
              end;
          end;
      end;
    if Not Flag then
      begin
        if ((ParamArray[0]='begin')and(not UUE_Founded)) then
         begin
           W1:=Str2Byte(ParamArray[1],-2);
           if ((W1>0) and (W1<778)) then
             begin
               SF:=ParamArray[2];
               StrValues[14]:=UpCaseStr(SF);
               SetToUUE;
             end;
         end;
      end;
    if Not Flag then
      begin
        if ((ParamArray[0]='sum')and(UUE_Founded)) then
         begin
           if ParamArray[3]='section' then
             begin
               SetFromUUE;
             end;
         end;
      end;
    if Not Flag then
      begin
        if ((ParamArray[0]='end')and(UUE_Founded)) then
         begin
           if ParamArray[1]='' then
             begin
               SetFromUUE;
             end;
         end;
      end;
  end;

Procedure ReadCookie;
Var
     TextFile         : File;
     S                : String;
     Num,I,J,K        : Word;
     C                : Char;
     Co               : Char;
     Indx             : LongInt;
     Buffer           : Array[0..299] of Char;
     Result           : Boolean;
     FI_Chars         : Array[0..3] of Char;
     FI_Int           : LongInt absolute FI_Chars;
  begin
    StrValues[11]:='';
    S:=FileNames[6];
    Assign(TextFile,S);
    Reset(TextFile,1);
    Num:=Random(MaxCookie);
    For I:=0 to 299 do
      Buffer[I]:=#0;
    Seek(TextFile,CookieIndex^[Num].Ofs);
    BlockRead(TextFile,Buffer[0],CookieIndex^[Num].Len,I);
    FI_Int:=0;
    S:='';
    For I:=0 to 279 do
      begin
        C:=Buffer[I];
        FI_Chars[3]:=C;
        For J:=0 to 2 do
          FI_Chars[J]:=FI_Chars[J+1];
        If FI_Int=$0a0d0a0d then
          begin
            I:=279;
          end
          else
          begin
            if ((FI_Chars[2]=#13)and(FI_Chars[3]=#10)) then
                begin
                  S:=S+#13;
                end
              else
                begin
                  Case C of
                    #13,#10     : Begin
                                  end;
                    #0          : I:=279;
                    #1..#9,#11..#12,#14..#255
                                : S:=S+C;
                    end;
                end;
          end;
      end;
    Close(TextFile);
    StrValues[11]:=S;
  end;

Procedure PostMessage (var Buf   : StringArray; Var Msg : PktMsgHeader;
                       var Result: Boolean);
Var       S1,S2,S3    : String;
          I,J,K       : Word;
          TempChars   : Array[0..255] of Char;
          Fido        : FidoAddress;
          Region      : Byte;

Function SysOpString(SysOp:CarbonType;AdrSwitch:Byte):String;
Var
        Addr,Name,S      : String;
  begin
    Addr:=Fido2Str(SysOp.Adr,AdrSwitch);
    Name:=SysOp.Name;
    Case CCViewMode of
      0 : Begin
            S:=Addr;
          end;
      1 : Begin
            S:=Name;
          end;
      2 : Begin
            S:=Addr+' ('+Name+')';
          end;
      3 : Begin
            S:=Name+' ('+Addr+')';
          end;
      end;
    SysOpString:=S;
  end;

  begin
    if CookieMode=2 then
      begin
        ReadCookie;
      end;
    With Msg do
      begin
        Constant2:=2;
        OrigNode := Addresses^[1].Node;
        DestNode := Addresses^[2].Node;
        OrigNet  := Addresses^[1].Net;
        DestNet  := Addresses^[2].Net;
        if EchoFlag then Attribute:=0
                    else Attribute:= MsgFlags;
        Cost     := 0;
        StrPCopy (DateTime,FormatString('%D0%D5%DT  %TT')+#0);
        Message[0]:=#0;
           {  砫 㦥 ப }
        FirstCludges(Msg);
        UUE_Founded:=False;
        UUE_Founded2:=False;
{       -------------------------------------------      }
        if ((XCrossListFlag) and (XCrossCounter>0)) then
          begin
            Case XCrossMode of
              0  : Begin
                     XCrossListFlag:=False;
                   end;
              1  : Begin
                     For I:=0 to XCrossCounter do
                       begin
                         IntValues[30]:=I;
                         if DefaultAreas^[I].ViewInList then
                           begin
                             S2:=XCrossString[0]+DefaultAreas^[I].N+#13;
                             AddLineToPChar(S2,Message,BooleanSets[0,3]);
                           end;
                       end;
                   end;
              2  : Begin
                     AddLineToPChar(XCrossString[0],
                                    Message,BooleanSets[0,3]);
                     For I:=0 to XCrossCounter do
                       begin
                         IntValues[30]:=I;
                         if DefaultAreas^[I].ViewInList then
                           begin
                             S2:=DefaultAreas^[I].N;
                             if I<XCrossCounter then S2:=S2+', ';
                             AddLineToPChar(S2,Message,BooleanSets[0,3]);
                           end;
                       end;
                     AddLineToPChar(#13,
                                    Message,BooleanSets[0,3]);
                   end;
              3  : Begin
                     AddLineToPChar(XCrossString[0]+#13,
                                    Message,BooleanSets[0,3]);
                     For I:=0 to XCrossCounter do
                       begin
                         IntValues[30]:=I;
                         if DefaultAreas^[I].ViewInList then
                           begin
                             S2:=XCrossString[1]+DefaultAreas^[I].N+#13;
                             AddLineToPChar(S2,Message,BooleanSets[0,3]);
                           end;
                       end;
                     AddLineToPChar(#13,
                                    Message,BooleanSets[0,3]);
                   end;
              end;
          end;
{       -------------------------------------------      }
        if ((CCopyListFlag) and (CCopyCounter>0)) then
          begin
            Case CCopyMode of
              0  : Begin
                     CCopyListFlag:=False;
                   end;
              1  : Begin
                     For I:=0 to CCopyCounter do
                       begin
                         IntValues[30]:=I;
                         if CarbonCopies^[I].ViewInList then
                           begin
                             S2:=SysOpString(CarbonCopies^[I],CCAdrMode);
                             S2:=CCopyString[0]+S2+#13;
                             AddLineToPChar(S2,Message,BooleanSets[0,3]);
                           end;
                       end;
                   end;
              2  : Begin
                     AddLineToPChar(CCopyString[0],
                                    Message,BooleanSets[0,3]);
                     For I:=0 to CCopyCounter do
                       begin
                         IntValues[30]:=I;
                         if CarbonCopies^[I].ViewInList then
                           begin
                             S2:=SysOpString(CarbonCopies^[I],16);
                             if I<CCopyCounter then S2:=S2+', ';
                             AddLineToPChar(S2,Message,BooleanSets[0,3]);
                           end;
                       end;
                     AddLineToPChar(#13,
                                    Message,BooleanSets[0,3]);
                   end;
              3  : Begin
                     AddLineToPChar(XCrossString[0]+#13,
                                    Message,BooleanSets[0,3]);
                     For I:=0 to XCrossCounter do
                       begin
                         IntValues[30]:=I;
                         if CarbonCopies^[I].ViewInList then
                           begin
                             S2:=SysOpString(CarbonCopies^[I],16);
                             S2:=CCopyString[1]+S2+#13;
                             AddLineToPChar(S2,Message,BooleanSets[0,3]);
                           end;
                       end;
                     AddLineToPChar(#13,
                                    Message,BooleanSets[0,3]);
                   end;
              end;
          end;
{       -------------------------------------------      }
        if DublSubjFlag then
          begin
            S2:=MsgStrings[5]+#13;
            AddLineToPChar(S2,Message,True);
          end;
        For I:=0 to CurrentLastLine-1 do
          begin
            S2:=ChangeRusN(Buf[I])+#13;
            StringHaveUUE(S2);
            AddLineToPChar(S2,Message,BooleanSets[0,3]);
          end;
           {   㦥 ப }
        EndCludges(Msg);
        ToUser   := MsgStrings[4];
        FromUser := MsgStrings[3];
        if UUE_Founded2
          then
            begin
              S2:=UUE_AddSubj;
              if UUE_AddFlag then S2:=S2+MsgStrings[0];
              Subject  := S2;
            end
          else Subject  := MsgStrings[0];
        AddMessageToPkt(Msg,Result);
        UUE_Founded:=False;
        UUE_Founded2:=False;
{        SetBooleanSets;}
      end;
  end;

Procedure PostFileToEcho(FileName:String; var Result:Boolean);
Var       S1,S2,S3    : String;
          I,J,K       : Word;
          TempChars   : Array[0..255] of Char;
          TF          : Text;
          Fido        : FidoAddress;
          Region      : Byte;
          ParamCnt    : Byte;
          Flag1,Flag2 : Boolean;
          CmndFlag,
          TextFlag    : Boolean;

Procedure PostArray;
Var
    I,J,K       : Word;
  begin
    { ᫨ CookieMode=1  ᣥp  }
    if CookieMode=1 then
      begin
        ReadCookie;
      end;
    { p 쬠 }
    if ((XCrossCounter>-1) and BooleanSets[0,7]) then
      begin
        For J:=0 to XCrossCounter do
          begin
            EchoFlag:=True;
            DefaultArea:=DefaultAreas^[J].N;
            MsgStrings[4]:=FormatString(DefaultTo.Name);
            Addresses^[2]:=Addresses^[1];
            PostMessage(MsgStrBuf^, Message,Result);
            if Result then
              begin
                WriteCurrentState(5);
              end;
          end;
      end;
    if ((CCopyCounter>-1) and BooleanSets[0,9]) then
      begin
        For J:=0 to CCopyCounter do
          begin
            EchoFlag:=False;
            MsgStrings[4] := CarbonCopies^[J].Name;
            Addresses^[2] := CarbonCopies^[J].Adr;
            PostMessage(MsgStrBuf^, Message,Result);
            if Result then
              begin
                WriteCurrentState(6);
              end;
          end;
      end;
    TextFlag:=False;
    CurrentLastLine:=0;
    MsgFlags  := MsgFlagsMain;
    MsgFlags2 := MsgFlags2Main;
  end;

Procedure AddMessageLine;
Var
    S,SS           : String;
    S1L            : Byte absolute S1;
    SL             : Byte absolute S;
    NewL           : Byte; {   p }
    I,J,K          : Byte;
    C              : Char;
    Flag           : Boolean;
    MaxLineLength2 : Byte;
  begin
    TextFlag:=True;
    CmndFlag:=False;
    MaxLineLength2:=MaxLineLength div 2;
    if S1L > MaxLineLength then
      begin
        S:=S1;
        I:=MaxLineLength;
        Flag:=False;
        While not Flag do
          begin
            C:=S[I];
            if (C in [' ',#8,#10,'.',',',';',':',')',']',
                      '-','=','+','*','!','}','?'])
              then
                begin
                  SS:=Copy(S,1,I);
                  MsgStrBuf^[CurrentLastLine]:=SS;
                  Inc(CurrentLastLine);
                  S :=Copy(S,I+1,255);
                  I:=MaxLineLength;
                  if SL>MaxLineLength
                    then I:=MaxLineLength
                    else
                      begin
                        Flag:=True;
                        MsgStrBuf^[CurrentLastLine]:=S;
                        Inc(CurrentLastLine);
                      end;
                end
              else
                begin
                  Dec(I);
                  if I<MaxLineLength2 then
                    begin
                      SS:=Copy(S,1,I);
                      MsgStrBuf^[CurrentLastLine]:=SS;
                      Inc(CurrentLastLine);
                      S :=Copy(S,I+1,255);
                      I:=MaxLineLength;
                      if SL>MaxLineLength
                        then I:=MaxLineLength
                        else
                          begin
                            Flag:=True;
                            MsgStrBuf^[CurrentLastLine]:=S;
                            Inc(CurrentLastLine);
                          end;
                    end;
                end;
          end;
      end
      else
        begin
          MsgStrBuf^[CurrentLastLine]:=S1;
          Inc(CurrentLastLine);
        end;
  end;

Procedure MessageCommand(I:Byte);
Var
    Flag        : Boolean;
    MDomain     : String;
  begin
    Case I of
      0   : Begin
              if Parameters[1].N=0 then
                begin
                  Fido:=DefaultFrom.Adr;
                  Str2Fido(Parameters[1].S, Fido,Region,MDomain,Flag1);
                  if Flag1 then Addresses^[1]:=Fido;
                end
                else
                begin
                  Addresses^[1]:=DefaultFrom.Adr;
                end;
              if Parameters[2].N=0 then
                begin
                  DefaultFrom.Name:=Parameters[2].S;
                  MsgStrings[3]:=Parameters[2].S;
                end
                else
                begin
                  MsgStrings[3]:=DefaultFrom.Name;
                end;
            end;
      1,2  : Begin
              if Parameters[1].N=0 then
                DefaultTo.Name:=Parameters[1].S;
            end;
      3..5 : Begin
               I:=I-3;
               if Parameters[1].N=0 then
                 begin
                   MsgStrings[I]:= Parameters[1].S;
                 end;
             end;
      6   : Begin
              if ((Parameters[1].N=0)and(Parameters[2].N=0)) then
                begin
                  CCopyCounter:=-1;
                  AddAddress2List(Parameters[1].S,Parameters[2].S);
                end;
            end;
      7,8 : Begin                        { %CCOPY %CC }
              If BooleanSets[0,13] then
                begin
                  CCopyCounter:=-1;
                  BooleanSets[0,13]:=False;
                end;
              If ((Parameters[1].N=0)and(Parameters[2].N=0)) then
                begin
                  AddAddress2List(Parameters[1].S,Parameters[2].S);
                end;
            end;
     11,12: Begin
              For I:=1 to ParamCnt do
                begin
                  If BooleanSets[0,13] then
                    begin
                      CCopyCounter:=-1;
                      BooleanSets[0,13]:=False;
                    end;
                  If (Parameters[I].N=0) then
                    begin
                      AddAddress2List(Parameters[I].S,'');
                    end;
                end;
            end;
      13  : Begin
              if Parameters[1].N=0 then
                begin
                  XCrossCounter:=-1;
                  AddArea2List(Parameters[1].S);
                end;
            end;
     14,15: Begin
              if Parameters[1].N=0 then
                begin
                  If BooleanSets[0,13] then
                    begin
                      XCrossCounter:=-1;
                      BooleanSets[0,13]:=False;
                    end;
                  AddArea2List(Parameters[1].S);
                end;
            end;
     18,19: Begin
              For I:=1 to ParamCnt do
                begin
                  if Parameters[I].N=0 then
                    begin
                      If BooleanSets[0,13] then
                        begin
                          XCrossCounter:=-1;
                          BooleanSets[0,13]:=False;
                        end;
                      AddArea2List(Parameters[I].S);
                    end;
                end;
            end;
     21,22: Begin
              Com_MsgFlags(0,ParamCnt,Parameters,Flag);
            end;
    23..25: Begin
              BooleanSets[0,9]:=False;
            end;
    26..28: Begin
              BooleanSets[0,7]:=False;
            end;
    29..31: Begin
              BooleanSets[0,3]:=False;
            end;
    32..34: Begin
              BooleanSets[0,1]:=False;
            end;
    35..37: Begin
              BooleanSets[0,5]:=False;
            end;
    38..40: Begin
              BooleanSets[0,11]:=False;
            end;
    41..43: Begin
              BooleanSets[0,13]:=True;
            end;
     44,45: Begin
              If Parameters[1].N<>ErrorLongInt then
                begin
                  if Parameters[1].N=0
                    then BooleanSets[0,0]:=True
                    else BooleanSets[0,0]:=False;
                  StrValues[27]:=CountedStringInternal[Parameters[1].N+6];
                  WriteCurrentState(7);
                end
            end;
      end;
  end;

  Begin
    Result:=True;
    CurrentLastLine:=0;
    CheckFile(FileName,Result);
    if Not Result then
      begin
        Global_Error:=True;
        ExitProcedure(4);
      end;
    Assign(TF,FileName);
    Reset(TF);
    if Result then
      begin
        With Message do
          begin
            CmndFlag:=False;
            TextFlag:=False;
            While not(EOF(TF)) do
              begin
                S1:='        ';
                Readln(TF,S1);
                S2:=S1;
                Case S1[1] of
                  ';' : Begin
                          if Not BooleanSets[0,11] then
                            begin
                              AddMessageLine;
                            end;
                        end;
                  '@' : Begin
                          if BooleanSets[0,1] then
                            begin
                              S1[1]:=#1;
                            end;
                          AddMessageLine;
                        end;
                  '%' : Begin
                          if BooleanSets[0,5] then
                            begin
                          {   }
                          {   }
                          CompileString(S2,ParamArray,ParamCnt);
                          if ParamCnt>=0 then
                            begin
                              S2:=UpCaseStr(ParamArray[0]);
                              I:=CommandsFind(S2,MaxNumMsgCommand,
                                              PostMsgCommand,
                                              Parameters,ParamArray);
                              if I<=MaxNumMsgCommand then
                                begin
                                  if TextFlag then
                                    begin
                                      PostArray;
                                    end;
                                  if not CmndFlag then
                                    begin
                                      SetBooleanSets;
                                    end;
                                  CmndFlag:=True;
                                  MessageCommand(I);
                                end
                                else
                                  begin
                                    AddMessageLine;
                                  end;
                            end;
                          end
                            else
                            begin
                              if BooleanSets[0,3] then
                                begin
                                  S1:='%'+S1;
                                end;
                              AddMessageLine;
                            end;
                        end
                  else
                    begin
                      AddMessageLine;
                    end;
                  end;
              end;
          end;
        If TextFlag then
          begin
            PostArray;
          end;
      end;
    Close(TF);
  end;

Procedure Array_Init;
Var    I:Integer;
       L1,L2     : LongInt;
       S:String;
       L:Byte absolute S;
  Begin
{    PostUtilCommandsRun[2]:=ExternalCommandsRun[0];}
    New(Addresses);
    GetMem(MsgStrBuf,       MaxMsgLines*80);
    GetMem(Message.Message, MsgMaxSize+16);
    GetMem(DefaultAreas,    MaxXCross*256);
    GetMem(CarbonCopies,    SizeOf(CarbonTypeArray));
    New(CookieIndex);
    For I:=0 to 1023 do
      CookieIndex^[I].Ofs:=0;
    For I:=0 to 9 do
      Addresses^[I]:=DefaultFidoAddress;
    S:=GetEnv('TEMP');
    if L>0 then Directory[4]:=S
           else Directory[4]:=Directory[0];
{                                                   }
    For I:=0 to 5 do
      begin
        Directory[I]:=FExpand(Directory[I]);
      end;
{                                                   }
    for I:=0 to MaxNumberCommand do
      begin
        ExternalCommand[I]:=PostUtilCommand[I];
        ExternalCommandsRun[I]:=PostUtilCommandsRun[I];
      end;
    ParamType[8]:=ParamTypeMsgFlags;
    ParamType[9]:=ParamTypePackerParam;
    ParamType[10]:=ParamTypePacketType;
    ParamType[11]:=ParamTypePostModeType;
    for I:=0 to 47 do
      begin
        CountedString[8+I]:=CountedStringMsgFlags[I];
      end;
    for I:=0 to 1 do
      begin
        CountedString[56+I]:=CountedStringPackerParam[I];
      end;
    for I:=0 to 2 do
      begin
        CountedString[58+I]:=CountedStringPacketType[I];
      end;
    for I:=0 to 9 do
      begin
        CountedString[61+I]:=CountedStringPostModeParam[I];
      end;
  end;

Procedure PostFileMask(Mask:String);
Var
          NewFileFlag   : Boolean;
          S1,S2         : String;
          L1,L2         : LongInt;
          W1,W2,W3,W4   : Word;
          CDT,DT        : DateTime;
          SL1           : Array[0..255] of Byte absolute S1;
          SL2           : Array[0..255] of Byte absolute S2;
          F             : File;
          D             : DirStr;
          N             : NameStr;
          E             : ExtStr;
  begin
    FindFirst(Mask, $20, CurrFile);
    FSplit(FExpand(Mask),Fdir,Fname,FExt);
    while ((DosError = 0) and WorkFlag) do
      begin
        SetBooleanSets;
        S1:=FDir+CurrFile.Name;
        StrValues[27]:=S1;
        WriteCurrentState(16);
        WorkFlag:=True;
        if ScanDirectoriesFlag then
          begin
            Assign(F,S1);
            Reset(F);
            GetFTime(F,L1);
            UnPackTime(L1,DT);
            if DT.Sec<60 then NewFileFlag:=False
                         else NewFileFlag:=True;
            UnPackTime(PackCurrentTime,CDT);
            WorkFlag:=False;
            WorkFlag:=True;
            With CDT do
              L1:=DateF(Day,Month,Year,W1);
            With DT do
              L2:=DateF(Day,Month,Year,W2);
            Case PostFileMode of
              0     : begin
                        WorkFlag:=True;
                      end;
              1     : begin
                        if W1=Period
                          then WorkFlag:=True;
                      end;
              2     : begin
                        if CDT.Day=Period
                          then WorkFlag:=True;
                      end;
              3     : Begin
                        if L1-L2=Period
                          then WorkFlag:=True;
                      end;
              4     : Begin
                      end;
              5     : Begin
                      end;
              6     : Begin
                      end;
              7     : Begin
                      end;
              8     : Begin
                      end;
              9     : Begin
                      end;
              end;
            Close(F);
          end;
        if WorkFlag then PostFileToEcho(S1,WorkFlag);
        if WorkFlag then
          begin
            if PostFileMode=0 then
              begin
                if Extensions[1][0]>#0 then
                  begin
                    FSplit(S1, D, N, E);
                    S2:=D+N+'.'+Extensions[1];
                    repeat
                      Assign(F,S1);
                      {$I-}
                      Rename(F,S2);
                      {$I+}
                      if IOResult=0 then
                        begin
                          StrValues[27]:=S1+' to '+S2;
                          WriteCurrentState(20);
                          WorkFlag:=True;
                        end
                        else
                        begin
                          WorkFlag:=False;
                          Inc(SL2[SL2[0]]);
                        end;
                    until WorkFlag;
                  end;
              end
              else
              begin
                Assign(F,S1);
                Case PostFileMode of
                  6   : Begin
                          Erase(F);
                          StrValues[27]:=S1;
                          WriteCurrentState(21);
                        end
                  else
                    begin
                      Reset(F,1);
                      SetFTime(F,PackCurrentTime);
                      Close(F);
                      StrValues[27]:=S1+' to '+S1;
                      WriteCurrentState(20);
                    end;
                  end;
              end;
          end;
        FindNext(CurrFile);
      end;
    If Not WorkFlag then
      begin
        ClosePktFile(WorkFlag);
        StrValues[27]:=FDir+CurrFile.Name;
        ExitProcedure(3);
      end;
  end;

Procedure AreaName2DirName  (    AreaName     : String;
                             var DirName      : String;
                             var Result       : Boolean);
Var
        OldDir                  : String;
        CurDir                  : String;
        OldEndChars             : CharSetArray;
        OldSymbChars            : CharSetArray;
        ParamCnt                : Byte;
        S1,S2,S3                : String;
        I,J,K                   : Integer;
  begin
    OldEndChars  := EndChars;
    OldSymbChars := SymbChars;
    EndChars     := EndChars + ['.'..'.'];
    GetDir (0,OldDir);
    CompileString(AreaName,ParamArray,ParamCnt);
    S1:=OldDir;
    For I:=0 to ParamCnt do
      begin
        ParamArray[0]:=Copy(ParamArray[0],1,8);
        {$I-}
        ChDir(ParamArray[0]);
        {$I-}
        if IOResult<>0 then
          begin
            if DosError=3 then
              begin
                {$I-}
                MkDir(ParamArray[0]);
                {$I+}
                if IOResult<>0 then
                  begin
                    GetDir(0,S1);
                    StrValues[27]:=S1+ParamArray[0];
                    ExitProcedure(7);
                  end;
              end;
          end;
      end;
    ChDir  (OldDir);
    EndChars  := OldEndChars ;
    SymbChars := OldSymbChars;
  end;

Procedure InternalPostUtil(    ConfigFileName : String;
                           var Result         : Boolean);
Var
       S                : String;
       I,J,K            : Integer;
       Indx             : LongInt;
       FI               : File of Char;
       FI_Chars         : Array [0..3] of Char;
       FI_Int           : LongInt absolute FI_Chars;
  begin
    ReadConfigFile(ConfigFileName);
    MsgFlagsMain  := MsgFlags;
    MsgFlags2Main := MsgFlags2;
    MsgFlagsAllow:=True;
    Randomize;
    If FileNames[6][0]>#0 then
      begin
        if CookieMode>0 then
          begin
            S:=FileNames[6];
            CheckFile(S,Result);
            if Result then
              begin
                Assign(FI,FileNames[6]);
                Reset(FI);
                MaxCookie:=-1;
                Indx:=0;
                CookieIndex^[0].Ofs:=0;
                for I:=0 to 3 do FI_Chars[I]:=#0;
                While not Eof(FI) do
                  begin
                    For I:=0 to 2 do
                      FI_Chars[I]:=FI_Chars[I+1];
                    Read(FI,FI_Chars[3]);
                    if FI_Int=$0a0d0a0d then
                      begin
                        Inc(Indx);
                        if Indx<=MaxNumCookies
                          then
                            begin
                              CookieIndex^[Indx].Ofs:=FilePos(FI);
                              J:=CookieIndex^[Indx].Ofs-
                                 CookieIndex^[Indx-1].Ofs;
                              if J<=280 then CookieIndex^[Indx-1].Len:=J;
                            end
                          else
                            Dec(Indx);
                      end;
                  end;
                MaxCookie:=Indx-1;
                Close(FI);
              end
              else
                CookieMode:=0;
          end
      end
      else CookieMode:=0;

    If TempFileName then
      begin
        FileNames[3]:=TempFile;
      end;
    If Global_Error then
      begin
        StrValues[27]:=ConfigFileName;
        Global_Error:=True;
        ExitProcedure(2);
      end
      else
      begin
        IntValues[0]:=IncludedFile;
        IntValues[1]:=LinesScanned;
        IntValues[2]:=CommandScanned;
        WriteCurrentState(10);
      end;

      if XCrossCounter<0 then
        begin
          ReadXCrossFile(FileNames[1]);
        end;

      if CCopyCounter<0 then
        begin
          ReadCCopyFile(FileNames[2]);
        end;

      if ((XCrossCounter=-1) and (CCopyCounter=-1)) then
        begin
          if Not ScanDirectoriesFlag then
            begin
              CCopyCounter:=0;
              CarbonCopies^[0]:=DefaultFrom;
            end;
        end;

    InitPathSeenBy;
  end;

Procedure ScanDirectories;
Var
          CurrentDir               : String;
          CurrentArea              : String;
          CurrentAreaNumber        : Integer;
          S1,S2,S3,S4              : String;
          Result                   : Boolean;
          I,J,K,L                  : Integer;
          ParamCnt                 : Byte;
          ScanAreaArray            : Array [0..MaxScanArea] of ScanAreaType;
          OldDir                   : String[80];

Procedure AddAreaDir;
  begin
    With ScanAreaArray[I] do
      begin
        Area    := UpCaseStr(ParamArray[0]);
        Dir     := UpCaseStr({FExpand(}ParamArray[1]){)};
        if Dir='' then
          begin
            AreaName2DirName(Area,S1,Result);
            Dir:=S1;
          end;
        GetDir(0,S4);
        {$I-}
        ChDir(Dir);
        {$I+}
        if IOResult<>0 then
          begin
            StrValues[27]:=Dir;
            ExitProcedure(7);
          end
          else
            begin
              GetDir(0,S1);
              ChDir(S4);
              Magic   := UpCaseStr(ParamArray[2]);
              Dir:=S1;
            end;
      end;
  end;

  begin
    S1:=FileNames[4];
    if S1='' then ExitProcedure(6);
    StrValues[27]:=S1;
    CheckFile(S1,Result);
    if not Result then
      begin
        ExitProcedure(5);
      end;
    GetDir(0,OldDir);
    {$I-}
    ChDir(Copy(Directory[1],1,Length(Directory[1])-1));
    {$I+}
    if IOResult<>0 then
      begin
        StrValues[27]:=Directory[1];
        ExitProcedure(7);
      end;
    Assign(TextFile,S1);
    Reset(TextFile);
    I:=-1;
    While not Eof(TextFile) do
      begin
        Readln(TextFile,S1);
        CompileString(S1,ParamArray,ParamCnt);
        if ParamCnt>0 then
          begin
            Inc(I);
            if I<=MaxScanArea then
              begin
                AddAreaDir;
              end;
          end;
      end;
    Close(TextFile);
    CurrentAreaNumber:=I;
    For I:=0 to CurrentAreaNumber do
      begin
        With ScanAreaArray[I] do
          begin
            StrValues[27]:='AreaDir '+Dir+' -> '+Area;
            WriteCurrentState(16);
            ChDir(Dir);
            XCrossCounter:=-1;
            AddArea2List(Area);
            S1:=DefaultConfigFile;
            CheckFile(S1,Result);
            if Result then
              begin
                InternalPostUtil(DefaultConfigFile,Result);
              end;
            S2:='*.'+Extensions[0];
            PostFileMask(S2);
          end;
      end;
    ChDir(OldDir);
  end;

Procedure AddressConvert(S1:String);
Var
    S2       : String;
  begin
    S2:=ReadToSpace(S1);
    S1:=ReadToSpace(S1);
    AddAddress2List(S2,FormatSysOpName(S1));
  end;

Procedure ScanCommandLine;
Const  MsgFlagConst : String[9] = 'MSGFLAGS';
Var
       S1,S2    : String;
       ParamCnt : Byte;
       I,J,K    : Word;
  begin
    ScanDirectoriesFlag:=False;
    TempAreaFlag:=False;
    TempFileName:=False;
    For I:=1 to ParamCount do
      begin
        S1:=UpCaseStr(ParamStr(I));
        if ((S1[1]='-')or(S1[1]='/')) then
          begin
            Case S1[2] of
              'C' : Begin
                      S1:=Copy(S1,3,80);
                      ConfigFileName:=S1;
                    end;
              'S' : Begin
                      ScanDirectoriesFlag:=True;
                    end;
              'A' : Begin
                      Case S1[3] of
                        '@'      : Begin
                                     S1:=Copy(S1,4,50);
                                     XCrossCounter:=-1;
                                     ReadXCrossFile(S1);
                                   end;
                        '+'      : Begin
                                     S1:=Copy(S1,4,50);
                                     AddArea2List(S1);
                                   end
                        else
                          begin
                            S1:=Copy(S1,3,50);
                            XCrossCounter:=-1;
                            AddArea2List(S1);
                          end;
                        end;
                    end;
              'N' : Begin
                      Case S1[3] of
                        '@'      : Begin
                                     S1:=Copy(S1,4,50);
                                     CCopyCounter:=-1;
                                     ReadCCopyFile(S1);
                                   end;
                        '+'      : Begin
                                     AddressConvert(Copy(ParamStr(I),4,60));
                                   end
                        else
                          begin
                            CCopyCounter:=-1;
                            AddressConvert(Copy(ParamStr(I),3,60));
                          end;
                        end;
                    end;
              'F' : Begin
                      Case S1[3] of
                        '@'      : Begin
                                     S1:=Copy(S1,4,50);
                                     CheckFile(S1,WorkFlag);
                                     if WorkFlag then
                                       begin
                                         Assign(TextFile,S1);
                                         Reset(TextFile);
                                         ReadLn(TextFile,S1);
                                         S1:=Copy(S1,4,50);
                                         Close(TextFile);
                                       end;
                                   end;
                        else
                          begin
                            S1:=Copy(S1,3,50);
                          end;
                        end;
                      S1:=MsgFlagConst+' '+S1;
                      CompileString(S1,ParamArray,ParamCnt);
                      MsgFlagsAllow:=True;
                      J:=CommandsFind(MsgFlagConst,MaxNumberCommand,
                                      PostUtilCommand,
                                      Parameters,ParamArray);
                      Com_MsgFlags(0, ParamCnt, Parameters, WorkFlag);
                      MsgFlagsAllow:=False;
                    end;
              '!' : Begin
                      S1:=Copy(S1,3,6);
                      ChangeBooleanSets(S1,WorkFlag);
                      if not WorkFlag then
                        begin
                          StrValues[27]:=S1;
                          WriteCurrentState(8);
                        end;
                    end;
              '?' : Begin
                      WriteLn(HelpScreen1);
                      WriteLn(HelpScreen2);
                      WriteLn(HelpScreen3);
                      Writeln(HelpScreen4);
                      ExitErrorLevel:=0;
                      ExitProcedure(0);
                    end
              else  Begin
                      StrValues[27]:=S1;
                      Global_Error:=True;
                      ExitProcedure(1);
                    end;
            end;
          end
          else
          begin
            if S1[1]='@' then
              begin
                S1:=Copy(S1,2,80);
                FileIsList  :=True;
              end
              else
              begin
                FileIsList  :=False;
              end;
            TempFileName:=True;
            TempFile:=S1;
          end;
      end;
  end;

begin
  Array_Init;

  { ----------------------------------------------------------------------- }

  ClrScr;
  StrValues[28]:=AuthorAddress;    { %RS }
  StrValues[29]:=AuthorFirstName;  { %RT }
  StrValues[30]:=AuthorSecondName; { %RU }
  StrValues[31]:=AuthorName;       { %RV }
  StrValues[32]:=ProgramNameStr;   { %RW }
  StrValues[33]:=VersionString;    { %RX }
  StrValues[34]:=CopyRightStr;     { %RY }
  StrValues[35]:=ReliseDateStr;    { %RZ }
  IntValues[33]:=VersionWord;      { %HX }
  IntValues[34]:=ReliseDateWord;   { %HY }
  TextAttr:=$0F;
  WritelnFormat('%RW v.%RX %RY.');
  TextAttr:=$09;
  WritelnFormat('Compiled     - %RZ. Author - %RV (%RS)');
  TextAttr:=12;
  WritelnFormat('Started time - %DT, %TT');
  Window(1,5,80,25);
  TextAttr:=7;

  { ----------------------------------------------------------------------- }

  OpenLogFile(FileNames[0],'%D4%DD/%DM %TT %RW v.%RX.');
  S1:='';
  For I:=1 to ParamCount do
    S1:=S1+ParamStr(I)+' ';
  WriteToLogFile('%D4%DD/%DM %TT Started: '+ParamStr(0),0);
  StrValues[27]:=S1;
  WriteCurrentState(9);

  I:=MemAvail;
  J:=MaxAvail;
  StrValues[27]:=Byte2Str(I)+'/'+Byte2Str(J);
  WriteToLogFile('-------------- Memory Available: %RR',0);

  FileIsList:=False;
  ScanCommandLine;

  InternalPostUtil(ConfigFileName,WorkFlag);

  CreateNewPkt(WorkFlag);

  if WorkFlag then
    begin
      if ScanDirectoriesFlag
        then ScanDirectories
        else
          begin
            if FileIsList then
              begin
                S1:=FileNames[3];
                CheckFile(S1,WorkFlag);
                if Not WorkFlag then
                  begin
                    StrValues[27]:=FileNames[3];
                    ExitProcedure(5);
                  end;
                FileNames[3]:=S1;
                Assign(TextFile,FileNames[3]);
                Reset(TextFile);
                While not EOF(TextFile) do
                  begin
                    Readln(TextFile,S1);
                    PostFileMask(S1);
                  end;
                Close(TextFile);
              end
              else
              begin
                PostFileMask(FileNames[3]);
              end;
          end;
      end;
  ClosePktFile(WorkFlag);
  ExitProcedure(0);
end.
